function [avgprec,reveal] = VNviaSGM(n,m,Lam,A,observe,truth, whichLAP)

%   [avgprec,reveal] = VNviaSGM(n,m,Lam,A,observe,truth)
%  n is vector of nonseed block sizes
%  m is vector of seed block sizes
%  Lam is communications matrix 
%  A is adjacency matrix
%  whichLAP is 1 or 2 according as slower/stable LAP or faster/less stable
%  
%  reveal is indicators of correctness along nomination list
% pre-pre-alpha sept 8, 2013

K=length(n);
sumn=sum(n);
summ=sum(m);
sumnm=sumn+summ;

% bookkeeping-- put all seeds first

loc=[];
for i=1:K
    findit=find(observe==i);
    loc=[loc; findit];
end
findit=find(observe==-1);
loc=[loc; findit];
A=A(loc,loc);
observe=observe(loc);
truth=truth(loc);

% make average graph

avloc=[];
for i=1:K
    avloc=[avloc; i*ones(m(i),1)];
end
for i=1:K
    avloc=[avloc; i*ones(n(i),1)];
end   

B=zeros(sumnm,sumnm);
for i=1:sumnm
    for j=1:sumnm
        B(i,j)=Lam(avloc(i),avloc(j));
    end
end
B=B-diag(diag(B));

% do graph match and nominate

corr=seedgraphmatchell2(A,B,summ,whichLAP);
nonfit=sum((A-B(corr,corr)).^2)';
susp= find ( (corr>summ)&(corr<=summ+n(1)) );
nonsusp= find(corr>summ+n(1));
suspT=[ nonfit(susp) rand(n(1),1) susp'];
suspT=sortrows(suspT);
nonsuspT=[  -nonfit(nonsusp) rand(sumn-n(1),1) nonsusp'];
nonsuspT=sortrows(nonsuspT);
nominate=[ suspT(:,3); nonsuspT(:,3) ];

% now check on our success

reveal=  truth(nominate)==1;
vecprec=zeros(1,n(1));
for k=1:n(1)
    vecprec(k)=sum(reveal(1:k))/k;
end
avgprec=mean(vecprec);

end

