function [avgprec,reveal] = VNviaSP(n,m,Lam,A,observe,truth)

%   [avgprec,reveal] = VNviaSP(n,m,Lam,A,observe,truth)
%  n is vector of nonseed block sizes
%  m is vector of seed block sizes
%  Lam is communications matrix 
%  A is adjacency matrix
%  
%  reveal is indicators of correctness along nomination list
% pre-pre-archive version Sept 9, 2013

K=length(n);
sumn=sum(n);
summ=sum(m);
sumnm=sumn+summ;
numdim=rank(Lam);

% spectrally embed

[XA,evalsA]=eigs(A,numdim);
 XA=XA*sqrt(abs(evalsA));
[IDXA,~,~,DA]=kmeans(XA,K);

% find the cluster corresponding to first block

w=zeros(1,K);
for i=1:K
    w(i)=sum( (observe==1)&(IDXA==i)  );
end
[~,rd]=max(w);
dist=DA(:,rd);

% nominate

W=[ dist rand(sumnm,1) [1:sumnm]' ];
ambig=find(observe==-1);
W=W(ambig,:);
sW=sortrows(W);
nominateorder=sW(:,3);

% check on success

reveal= truth(nominateorder)==1;
vecprecis=zeros(1,n(1));
for i=1:n(1)
    vecprecis(i)=sum(reveal(1:i))/i;
end
avgprec=mean(vecprecis);

end

