function [mapCAN,meansuccessCAN,mapSGM,meansuccessSGM,mapSP,meansuccessSP,mapML,meansuccessML] = implement(n,m,Lam,numsims,whichtodo,whichLAP)

% [mapCAN,meansuccessCAN,mapSGM,meansuccessSGM,mapSP,meansuccessSP,mapML,meansuccessML] = implement(n,m,Lam,numsims,whichtodo,whichLAP)
%
%  n is vector of nonseed block sizes
%  m is vector of seed block sizes
%  Lam is communications matrix 
%  whichtodo entries 1,2,3 indicate VNviaCAN, VNviaSGM, VNviaSP, VNviaML
%  whichLAP is 1 or 2 according as slower/stable LAP or faster/less stable
%  map is mean average precision, 
%  meansuccess is empirical prob of success by rank

sumn=sum(n);
mapCAN=0;
meansuccessCAN=zeros(1,sumn);
mapSGM=0;
meansuccessSGM=zeros(1,sumn);
mapSP=0;
meansuccessSP=zeros(1,sumn);
mapML=0;
meansuccessML=zeros(1,sumn);

for i=1:numsims
   i
   [ A,observe,truth ] = makeSBM(n,m,Lam);
   if whichtodo(1)==1
       [probs,avgprec,reveal] = VNviaCAN(n,m,Lam,A,observe,truth);
       mapCAN=mapCAN+avgprec/numsims;
       meansuccessCAN=meansuccessCAN+reveal'/numsims;
   end
   if whichtodo(2)==1
       [avgprec,reveal] = VNviaSGM(n,m,Lam,A,observe,truth,whichLAP);
       mapSGM=mapSGM+avgprec/numsims;
       meansuccessSGM=meansuccessSGM+reveal'/numsims;
   end
   if whichtodo(3)==1
       [avgprec,reveal] = VNviaSP(n,m,Lam,A,observe,truth);
       mapSP=mapSP+avgprec/numsims;
       meansuccessSP=meansuccessSP+reveal'/numsims;
   end
   if whichtodo(4)==1
       [avgprec,reveal] = VNviaML(n,m,Lam,A,observe,truth,whichLAP);
       mapML=mapML+avgprec/numsims;
       meansuccessML=meansuccessML+reveal'/numsims;
   end
end

end

