function [avgnomposition] = nextDoMemex(n1,n2,m1,m2,A,truth,whichLAP,numsims)
%  [ ] = DoMemex(n1,n2,m1,m2,A,truth,whichLAP,numsims)
%  
%  memex; vtcs avg place in nomination order
%
%  n is vector of nonseed block sizes
%  m is vector of seed block sizes
%
%  A is (grand) adjacency matrix
%  whichLAP is 1 or 2 according as slower/stable LAP or faster/less stable


A=full(A);

red=find(truth==1);
nonred=find(truth==2);

numred=length(red);
numnonred=length(nonred);

numquery=zeros(1,numred+numnonred);
nomposition=zeros(1,numred+numnonred);
avgnomposition=zeros(1,numred+numnonred);

for i=1:numsims
    i
    Q=randperm(numred);
    unknownred=      red(   Q(1:n1      )  );
    knownred=        red(   Q(1+n1:m1+n1)  );
    Q=randperm(numnonred);
    unknownnonred=nonred(   Q(1:n2      )  );
    knownnonred=  nonred(   Q(1+n2:m2+n2)  );
    
    observe=truth;
    observe(unknownred)=-1;
    observe(unknownnonred)=-1;

    Lambda=zeros(2,2);
    Lambda(1,1)=sum(sum(A(knownred,knownred)))/(m1^2-m1);
    Lambda(2,2)=sum(sum(A(knownnonred,knownnonred)))/(m2^2-m2);
    Lambda(1,2)=sum(sum(A(knownred,knownnonred)))/(m1*m2);
    Lambda(2,1)=Lambda(1,2);
    
    for ii=1:2
        for jj=1:2
            if Lambda(ii,jj)<.001
                Lambda(ii,jj)=.001;
            end
            if Lambda(ii,jj)>.999
                Lambda(ii,jj)=.999;
            end
        end
    end
    
    
    v=[knownred; knownnonred; unknownred; unknownnonred];
    Q=randperm(n1+n2+m1+m2);
    v=v(Q);
    
    B=A(v,v);
    tttruth=truth(v);
    observe=observe(v);
    
    n=[n1 n2];
    m=[m1 m2];
    [nominorder] = nextVNviaML(n,m,Lambda,B,observe,tttruth, whichLAP);
    
    
    for j=1:(n1+n2)
        zz=v(nominorder(j));
        numquery(zz)=numquery(zz)+1;
        nomposition(zz)=nomposition(zz)+j;
    end
    avgnomposition=nomposition./numquery; 
end

